/* LISTEN.C: To test receiving data from the amiga
 * 1. on the PC, type: listen
 * 2. on the Amiga, type: machaddr 4
 *                        talk 1 4
 */
#include <stdio.h>
#include <signal.h>
#include "pardev.h"
#include "dos.h" /* only for crtlbrk() */
#include "string.h" /* only for memcpy() function */

unsigned char buffer[255];
int Length=0;
int Trigger=0;

int ParAbort(void)
{
  par_stop();
  printf("Aborted.\n");
  exit(1);
}

/* interrupt service routine, called from parvec() */
void parint(void)
{
 printf("i\n");
 if (pardataready())
 {
   Length=parread(buffer,255);
   if (Length > 0) Trigger+=1;
 }
}

main(int argc,char **argv)
{
 int cnt;

 par_init(1,0x278);
 ctrlbrk(ParAbort); /* be sure interrupts will be restored when aborted */

 printf("port: chksum: length:  data:\n");
 while(1)
 {
  if (Trigger)      /* will be set in parint */
  {
    if (Trigger > 1)
    { printf("buffer overflow, data lost!\n");
      Trigger=0;
    }
    else
    {
      Trigger=0;

      /* print the header content */
      /* yech!, casting (char) to (long) didn't work.. */
      printf("%04x  %04x   %08x  ",buffer[0]*256+buffer[1],
                                   buffer[2]*256+buffer[3],
                                   buffer[4]*65536+buffer[5]*4096+buffer[6]*256+buffer[7]);
      /* print the data content */
      for (cnt=8;cnt<Length;cnt++)
      { if ((int)buffer[cnt] > 0x1f) printf("%c",buffer[cnt]);
        else printf(".");
      }
    }
  }
 }
}
